@rem = '--*-Perl-*--
@echo off
if "%OS%" == "Windows_NT" goto WinNT
perl -x -S "%0" %1 %2 %3 %4 %5 %6 %7 %8 %9
goto endofperl
:WinNT
perl -x -S "%0" %*
if NOT "%COMSPEC%" == "%SystemRoot%\system32\cmd.exe" goto endofperl
if %errorlevel% == 9009 echo You do not have Perl in your PATH.
goto endofperl
@rem ';
#!perl
#line 14

############################################
#                                          #
#  The script "flatten.bat" is             #
#                                          #
#  Copyright (C) 2005 by Steffen Beyer.    #
#  All rights reserved.                    #
#                                          #
#                                          #
#  The script "flatten.bat" is             #
#                                          #
#  free software; you can redistribute it  #
#  and/or modify it under the same terms   #
#  as Perl itself.                         #
#                                          #
############################################

use strict;

my($Self,$Top,@Task,$Item);

$Self = $0; $Self =~ s!^.*[\/\\]!!; $Self =~ s!\.[^\.\/\\]*$!!;

unless (@ARGV)
{
    die "Usage: $Self <Directory>\n";
}

while (@ARGV)
{
    $Top = shift;
    unless (opendir(TOP, $Top))
    {
        warn "$Self: can't open directory <$Top>: $!\n";
        next;
    }
    @Task = map { "$Top/$_" }
            sort
            grep { !/^\.\.?$/ and (-d "$Top/$_") }
            readdir(TOP);
    unless (closedir(TOP))
    {
        warn "$Self: can't close directory <$Top>: $!\n";
    }
    foreach $Item (@Task) { Process($Item); }
}

sub Process
{
    my($Dir) = shift;
    my(@List,$Item,$Number,$Source,$Target);

    unless (opendir(DIR, $Dir))
    {
        warn "$Self: can't open directory <$Dir>: $!\n";
        return;
    }
    @List = sort { $a->[1] <=> $b->[1] || lc($a->[0]) cmp lc($b->[0]) || $a->[0] cmp $b->[0] }
            map  { if (/^(\d+)/) { [$_,$1] } elsif (/^.*?\D(\d+)\.wav$/i) { [$_,$1] } else { [$_,0] } }
            grep { !/^\.\.?$/ and (-f "$Dir/$_") and /^(?:\d+.*|.*?\D\d+)\.wav$/i }
            readdir(DIR);
    unless (closedir(DIR))
    {
        warn "$Self: can't close directory <$Dir>: $!\n";
    }
    foreach $Item (@List)
    {
        $Number = sprintf("%02d", $Item->[1]);
        $Source = $Dir . '/' . $Item->[0];
        $Target = $Dir . "/${Number}_Track${Number}.wav";
        unless (rename($Source,$Target))
        {
            warn "$Self: can't rename <$Source> to <$Target>: $!\n";
        }
    }
}

__END__
:endofperl
