@rem = '--*-Perl-*--
@echo off
if "%OS%" == "Windows_NT" goto WinNT
perl -x -S "%0" %1 %2 %3 %4 %5 %6 %7 %8 %9
goto endofperl
:WinNT
perl -x -S "%0" %*
if NOT "%COMSPEC%" == "%SystemRoot%\system32\cmd.exe" goto endofperl
if %errorlevel% == 9009 echo You do not have Perl in your PATH.
goto endofperl
@rem ';
#!perl
#line 14

############################################
#                                          #
#  The script "move_mp3.bat" is            #
#                                          #
#  Copyright (C) 2005 by Steffen Beyer.    #
#  All rights reserved.                    #
#                                          #
#                                          #
#  The script "move_mp3.bat" is            #
#                                          #
#  free software; you can redistribute it  #
#  and/or modify it under the same terms   #
#  as Perl itself.                         #
#                                          #
############################################

use strict;

my($Self,$Source,$Target,@Task,$Item);

$Self = $0; $Self =~ s!^.*[\/\\]!!; $Self =~ s!\.[^\.\/\\]*$!!;

unless (@ARGV > 1)
{
    die "Usage: $Self <SourceDir>+ <TargetDir>\n";
}

$Target = pop;

while (@ARGV)
{
    $Source = shift;
    unless (opendir(TOP, $Source))
    {
        warn "$Self: can't open directory <$Source>: $!\n";
        next;
    }
    @Task = sort
            grep { !/^\.\.?$/ and (-d "$Source/$_") }
            readdir(TOP);
    unless (closedir(TOP))
    {
        warn "$Self: can't close directory <$Source>: $!\n";
    }
    foreach $Item (@Task) { Process($Source,$Target,$Item); }
}

sub Process
{
    my($source,$target,$name) = @_;
    my($srcdir,$trgdir);

    $srcdir = "$source/$name/";
    $trgdir = "$target/$name";

    unless (-d $trgdir)
    {
        unless (mkdir($trgdir))
        {
            warn "$Self: can't mkdir directory <$trgdir>: $!\n";
            return;
        }
    }
    $srcdir =~ s!/!\\!g;
    $trgdir =~ s!/!\\!g;
    $srcdir = qq("$srcdir\\"*.mp3);
    $trgdir = qq("$trgdir");
#   print "system('copy', $srcdir, $trgdir);\n";
    system('copy', $srcdir, $trgdir);
#   print "system('del', $srcdir);\n";
    system('del', $srcdir);
}

__END__
:endofperl
